#include <iostream>
using namespace std;

//=============================================================================
// p:
//=============================================================================

// p has tuples (1,1), (1,2), (2,1), (4,2)

class p_cursor_1 {
private:
	int Row;
	int Col_1;
	int Col_2;
	int Saved_Row;

	void set_data()
	{
		switch(Row) {
		case 1:
			Col_1 = 1;
			Col_2 = 3;
			break;
		case 2:
			Col_1 = 1;
			Col_2 = 4;
			break;
		case 3:
			Col_1 = 3;
			Col_2 = 8;
			break;
		case 4:
			Col_1 = 4;
			Col_2 = 2;
			break;
		default:
			Col_1 = -1;
			Col_2 = -1;
		}
	}

public:
	p_cursor_1()
	{
		Row = -1;
		Col_1 = -1;
		Col_2 = -1;
		Saved_Row = -1;
	}

	void open()
	{
		Row = 0;
	}

	bool fetch()
	{
		if(Row < 0) {
			cerr << "p_cursor_1 not open.\n";
			return false;
		}
		if(Row >= 4)
			return false;

		Row++;
		set_data();
		return true;
	}

	int col_1()
	{
		return Col_1;
	}

	int col_2()
	{
		return Col_2;
	}

	void save()
	{
		Saved_Row = Row;
	}

	void restore()
	{
		Row = Saved_Row;
		set_data();
	}

	void close()
	{
		Row = -1;
		Col_1 = -1;
		Col_2 = -1;
	}
};

//=============================================================================
// q:
//=============================================================================

// q has tuples (4,5), (3,6), (1,7), (2,8)

class q_cursor_2 {
private:
	int Row;
	int Col_1;
	int Col_2;
	int Saved_Row;

	void set_data()
	{
		switch(Row) {
		case 1:
			Col_1 = 4;
			Col_2 = 5;
			break;
		case 2:
			Col_1 = 3;
			Col_2 = 6;
			break;
		case 3:
			Col_1 = 1;
			Col_2 = 7;
			break;
		case 4:
			Col_1 = 2;
			Col_2 = 8;
			break;
		default:
			Col_1 = -1;
		}
	}

public:
	q_cursor_2()
	{
		Row = -1;
		Col_1 = -1;
		Col_2 = -1;
		Saved_Row = -1;
	}

	void open()
	{
		Row = 0;
	}

	bool fetch()
	{
		if(Row < 0) {
			cerr << "q_cursor_2 not open.\n";
			return false;
		}
		if(Row >= 4)
			return false;

		Row++;
		set_data();
		return true;
	}

	int col_1()
	{
		return Col_1;
	}

	int col_2()
	{
		return Col_2;
	}

	void save()
	{
		Saved_Row = Row;
	}

	void restore()
	{
		Row = Saved_Row;
		set_data();
	}

	void close()
	{
		Row = -1;
		Col_1 = -1;
		Col_2 = -1;
	}
};

//=============================================================================
// Rule implementation:
//=============================================================================


// p(X, Y) & q(Y, Z).
// Gewuenschte Sortierung: X, Z

void print(int X, int Y, int Z)
{
	cout << "X = " << X << ", Y = " << Y << ", Z = " << Z << "\n";
}

main()
{
p_cursor_1 p;
q_cursor_2 q;
bool more_p;
int X, Y, Z;

// Test of p:
cout << "p_1:\n";
p.open();
while(p.fetch()) {
	cout << p.col_1() << ", " << p.col_2() << "\n";
}
p.close();
cout << "\n";

// Test of q:
cout << "q_2:\n";
q.open();
while(q.fetch()) {
	cout << q.col_1() << ", " << q.col_2() << "\n";
}
q.close();
cout << "\n";

// Main Part:
cout << "p(X, Y) & q(Y, Z)  ordered by X, Z:\n";
p.open();
more_p = p.fetch();
while(more_p) { // Loop over X-values from p
	X = p.col_1();
	p.save();
	q.open();
	while(q.fetch()) { // Loop over q
		Y = q.col_1();
		Z = q.col_2();
		p.restore();
		do {
			if(p.col_2() == Y)
				print(X, Y, Z);
		} while((more_p = p.fetch()) && p.col_1() == X);
	}
	q.close();
}
p.close();

}

